Bug Hunting Session
Bug 86117 - LO unexpectedly quits when closing Bullets/Numbering popups from the sidebar (a11y)
Summary: LO unexpectedly quits when closing Bullets/Numbering popups from the sidebar ...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: framework (show other bugs)
Version:
(earliest affected)
4.4.0.0.alpha2
Hardware: Other All
: medium normal
Assignee: Maxim Monastirsky
URL:
Whiteboard: target:4.5.0 target:4.4.0.0.beta2
Keywords:
Depends on:
Blocks:
 
Reported: 2014-11-10 15:26 UTC by sophie
Modified: 2014-12-02 12:48 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
Screeshot of the dialog before the crash (39.92 KB, image/png)
2014-11-26 12:55 UTC, sophie
Details

Note You need to log in before you can comment on or make changes to this bug.
Description sophie 2014-11-10 15:26:55 UTC
Hi, steps to reproduce
- open a Writer document
- click on Numbering On/Off on the side panel
- don't select anything
- click again to close the dialog
- a small dialog appears with OK button
- press ok
==> Writer crashes
version Version: 4.4.0.0.alpha2+
Build ID: 3d16e8593ac1e9d90f0a033732766907476822f9
TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:master, Time: 2014-11-09_23:54:19
Ubuntu 14.10 x64 - Sophie
Comment 1 Maxim Monastirsky 2014-11-10 16:25:07 UTC
Hi sophie,

I can't reproduce with the same build you're using under Fedora 20 and Ubuntu 14.10 livecd (both 64-bit).

Does it happen in Impress with the Slide/Slide Layout buttons (from the small toolbar near the Standard toolbar)? (I'm asking because they're using the same control.)
Comment 2 sophie 2014-11-10 16:49:21 UTC
Hi Maxim, I just install the prerelease Version: 4.4.0.0.alpha2
Build ID: 24f0a5815f581dd9a7f09d30213a379edee6e9ac and it doesn't crash any more with this one - Thanks for testing. I'm closing it now.
Comment 3 Maxim Monastirsky 2014-11-10 16:56:37 UTC
(In reply to sophie from comment #2)
> Hi Maxim, I just install the prerelease Version: 4.4.0.0.alpha2
> Build ID: 24f0a5815f581dd9a7f09d30213a379edee6e9ac and it doesn't crash any
> more with this one - Thanks for testing. I'm closing it now.
But this build predates the one you tested earlier, and yesterday I did some changes in the code of this button! So please keep your eye on it, and test with newer builds when they're available.
Comment 4 sophie 2014-11-10 16:58:41 UTC
Ok, I'll do :) Sophie
Comment 5 sophie 2014-11-12 09:38:45 UTC
Maxim, I still have a crash with this one Version: 4.4.0.0.alpha2+
Build ID: 98f9baa5253f7bb8034f148519f31f548b1452fa
TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:master, Time: 2014-11-12_00:13:54 on Ubuntu 14.10 x64, so I put it back to unconfirmed. Sophie
Comment 6 Maxim Monastirsky 2014-11-12 10:32:39 UTC
Actually I'm able to reproduce it only with Orca screen reader enabled. Is this the case for you?
Comment 7 sophie 2014-11-12 10:44:33 UTC
Accessibility (universal access) is currently disabled on my laptop, so no Orca running.
Comment 8 Maxim Monastirsky 2014-11-12 15:31:31 UTC
(In reply to sophie from comment #7)
> Accessibility (universal access) is currently disabled on my laptop, so no
> Orca running.
Hmm, It reminds me Bug 79913 where some people (you and JBF) reproduced similar bug without accessibility turned on, but the others (Julien in comment 19) only with accessibility.
Comment 9 sophie 2014-11-26 12:55:47 UTC
Created attachment 110059 [details]
Screeshot of the dialog before the crash

I still reproduce the crash, I added a screenshot of the dialog that appear when closing the numbering window. When I click the ok button, LibreOffice crashes. 
Version: 4.4.0.0.beta1+
Build ID: 15156e06c9a3a73a375445955265999731800458
TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:libreoffice-4-4, Time: 2014-11-26_01:59:16
Locale: fr_FR Ubuntu 14.10 x64
Comment 10 Maxim Monastirsky 2014-11-27 19:34:50 UTC
Given the information we collected in Bug 86112, let's assume that it's indeed accessibility related, and that I reproduced in comment 6 the same problem you have. So setting as NEW.

Also I tried to put on the sidebar other buttons with svtools::ToolbarMenu based drop-downs, and they all have this bug, so I'll amend the title of the bug.
Comment 11 Maxim Monastirsky 2014-11-28 00:03:47 UTC
OK, I shouldn't blame svtools::ToolbarMenu. In reality it's IndexOutOfBoundsException in VCLXAccessibleToolBox::getAccessibleChild, after ToolBox::GetItemPos returns TOOLBOX_ITEM_NOTFOUND.
Comment 12 Maxim Monastirsky 2014-11-28 12:59:57 UTC
I submitted a potential fix to gerrit: https://gerrit.libreoffice.org/13173/
Comment 13 Maxim Monastirsky 2014-11-30 12:10:36 UTC
I pushed this fix to master - http://cgit.freedesktop.org/libreoffice/core/commit/?id=ef8e38266b13800518830917a71dde4d3ee8f7ef

@sophie: Would be great if you could test it with 4.5 daily, to see whether the crash was gone there.
Comment 14 sophie 2014-12-01 10:36:29 UTC
Hi Maxim, whith the last daily it doesn't crash anymore :)
Version: 4.5.0.0.alpha0+
Build ID: 317b5bc5f801135b027e02d5acfc407cc2d05689
TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:master, Time: 2014-12-01_00:15:34
Locale: fr_FR
Thanks a lot! I'll try to investigate where those accessibility things are running on Ubuntu. Sophie
Comment 15 Commit Notification 2014-12-02 12:28:54 UTC
Maxim Monastirsky committed a patch related to this issue.
It has been pushed to "libreoffice-4-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=13f5ccd98ee7c623d5d4a53da56df668f98f7353&h=libreoffice-4-4

fdo#86117 a11y: Exception when closing popup from ToolBox w/o separator

It will be available in 4.4.0.0.beta2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 16 Maxim Monastirsky 2014-12-02 12:31:32 UTC
Let's hope it's fixed now.

(In reply to sophie from comment #14)
> I'll try to investigate where those accessibility things are
> running on Ubuntu.
Could you look at the list of running processes? Maybe you have speech-dispatcher there?
Comment 17 sophie 2014-12-02 12:48:14 UTC
(In reply to Maxim Monastirsky from comment #16)
> Let's hope it's fixed now.
> 
> (In reply to sophie from comment #14)
> > I'll try to investigate where those accessibility things are
> > running on Ubuntu.
> Could you look at the list of running processes? Maybe you have
> speech-dispatcher there?

Yes, I found it, it's an at-spi-bus-launcher. Thanks for the patch and your help :) I'll test your patch in the next beta - Sophie